# Who's who

Bon, on aime bien choisir des noms rigolos pour les vms, mais parfois ça amène à
un peu de confusion. Du coup, on va répertorier ici les différentes machines
(virtuelles ou non) et leurs différentes fonctions. Si une machine n'est pas
renseigné, n'hésitez pas à aller jeter un coup d'œil sur ansible ou à raller sur
#roots :)

## Zamok
C'est le serveur physique des adhérent⋅es. Il sert principalement à deux choses,
donner un terminal aux adhérents et destination finale des mails. C'est aussi
lui qui hébèrge les pages personnelles des adhérent⋅es. Le [webirc
persistent](https://webirc.crans.org) y est aussi hébergé.

Liste des logiciels installés :
  - postfix + opendkim + rspamd
  - apache (bouh)
  - webirc

Redémarrage et mise à jour :
  - pas de redémarrage automatique
  - mise à jour manuelle de linux et nftables
  - éviter de redémarrer car les adhérent⋅es peuvent avoir des scripts qui tournent

## Tealc
C'est le serveur qui hébèrge les disques de nos vms. C'est un gros machins
pleins de disques qui utilise zfs pour exposer une pool en nfs sur le réseau
pour qu'elle soit montée par le cluster proxmox. Il héberge aussi un serveur
postgres sur lequel sont hébergées (presque) toutes les bases de données du
crans. C'est aussi lui qui héberge les homes des nounous et le mirroir des
logiciels.

Liste de logiciels installés :
  - zfs
  - postgres
  - nginx

Redémarrage et mise à jour :
  - pas de redémarrage automatique
  - mise à jour manuelle de postgresql
  - éviter de redémarrer car tous les services perdent leur disques

## Cameron
C'est le serveur qui héberge les homes des adhérent⋅es et leurs répertoires
mails. C'est aussi depuis lui que sont effectués les backups quotidiennes des
données des adhérent⋅es. Une de ses pools sert à stocker et à exposer sur le
réseau les disques des vms des adhérent⋅es pour qu'elles soit montées sur le
cluster proxmox des adhérent⋅es.

Liste de logiciels installés :
  - zfs

Redémarrage et mise à jour :
  - pas de redémarrage automatique
  - éviter de redémarrer car tous les adhérents perdent leur disques

## Sam, Daniel, Jack : le cluster proxmox du crans
Les trois serveurs sont organisés en un cluster proxmox pour hébergé les
machines virtuelles du crans. Ils hébergent en sus une copie en lecture seule
des bases de données et un replicat du serveur ldap.

Liste de logiciels installés :
  - proxmox
  - postgres
  - slapd

Redémarrage :
  - pas de redémarrage automatique
  - migrer les VM avant de redémarrer

### wall-e : le serveur ldap
C'est le serveur qui hébèrge le ldap d'administration. Sur celui-ci sont
consignés toutes nos machines, les utilisateurices qui ont accès au réseau et
les privilèges dont iel dispose sur celui-ci, la configuration des zones dns.

Liste de logiciels installés :
  - slapd

Redémarrage et mise à jour automatique

### routeur-{sam,daniel,jack} : les routeurs
Les routeurs sont responsables de connecter le reste du crans au reste du monde.
Chacun d'entre eux est équipé pour pouvoir effectuer cette tache seule. À tout
instant un seul d'entre eux s'occupe du routage et les autres attendent. Si un
problème devait arriver au routeur actif, l'un des deux prendraient le relai via
keepalived. Chacun des routeurs disposent d'une copie du parefeu généré par un
script, d'un serveur radvd pour broadcast des router advertisement sur le
réseau des adhérent⋅es, d'un serveur dhcp pour aider les machines des
adhérent⋅es à configurer leur ipv4 et d'un serveur bird pour échanger des routes
avec nos isps (aurore et via).

Liste de logiciels installés :
  - nftables
  - isc-dhcp-server
  - radvd
  - bird
  - keepalived

Redémarrage et mise à jour :
  - pas de redémarrage automatique
  - mise à jour manuelle de linux et nftables
  - ne pas redémarrer plusieurs en même temps et faire attention avac routeur-sam car c'est notre routeur principal (un peu de downtime si on ne change pas les routes avant)

### routeur-2754 : le routeur pour l'ENS
Ce routeur est responsable de connecter le Crans au VLAN 2754 de l'ENS.

Redémarrage et mise à jour :
  - pas de redémarrage automatique
  - mise à jour manuelle de linux et nftables
  - redémarrage manuel possible (surtout tant qu'il sert à rien)

### eclat : le mirroir publique
C'est la machine virtuelle qui synchronise les mirroirs de logiciels et les
expose au reste d'internet pour que les adhérent⋅es puissent télécharger les
logiciels. Le mirroir est hébergé sur tealc et c'est ce serveur que toutes nos
machines viennent intérroger pour se mettre à jour. Seul les machines
exterieures utilisent eclat.

Liste de logiciels installés :
  - rsyncd
  - vsftpd
  - nginx
  - apt-mirror

Redémarrage et mise à jour automatique.

### gitzly : le serveur gitlab
C'est le serveur gitlab du crans.

Redémarrage et mise à jour :
  - redémarrage automatique
  - mise à jour manuelle de gitlab

### gitlab-ci : le serveur d'intégration continue
C'est le serveur sur lesquels sont exectués les taches d'intégration continue
grâce à docker (beurk).

Redémarrage et mise à jour automatique.

### owncloud: le serveur owncloud
C'est le serveur owncloud du crans.

Redémarrage et mise à jour :
  - redémarrage automatique
  - mise à jour manuelle de owncloud

### roundcube : le (seul) webmail
C'est le webmail sur lequel les adhérent⋅es peuvent consulter leur mails. C'est
un logiciel php.

Redémarrage et mise à jour automatique.

### voyager : framadate & la meilleure vm
C'est la machine virtuelle qui héberge framadate (un logiciel php), et une base
de donnée mysql. Mais surtout c'est une vm qui a beaucoup servi de vms de tests
random, son état est donc chaotique et incertain.

Redémarrage et mise à jour automatique.

### kenobi: les pads
C'est la machine virtuelle qui héberge les pads et les tmpads.

Redémarrage et mise à jour automatique.

### ethercalc: les tableurs
C'est la machine virtuelle qui héberge les tabeurs ethercalc.

Redémarrage et mise à jour automatique.

### mailman : les listes de diffusion
C'est la machine virtuelle qui héberge les listes de diffusion. On utilise
mailman3, un logiciel django et la machine dispose aussi de son instance de
postfix pour pouvoir envoyer et recevoir les mails.

Redémarrage et mise à jour automatique.

### belenios : la démocratie
C'est la machine virtuelle qui héberge le logiciel éponyme qui sert à organiser
des éléctions sécurisées. C'est un logiciel en ocaml, use with care or with L3
info.

Redémarrage et mise à jour automatique.

### apprentis : la machine virtuelle des apprenti⋅es
Play ground pour que les apprenti⋅es puissent s'amuser à faire ce qu'iels
veulent. À priori rien est installé dessus mais tout peut-être installé dessus.

Redémarrage et mise à jour automatique.

### ptf : la mémoire (fatiguée)
C'est le serveur ftp sur lequel est hebergé les vidéos des installs party du
crans. Il dispose d'un serveur vsftpd et d'un serveur nginx. Il est peu utilisé.

Redémarrage et mise à jour automatique.

### flirt : le ldap des machines des adhérent⋅es
C'est la machine virtuelle qui héberge le ldap sur lequel sont consignés les
machines virtuelles des adhérent⋅es et des clubs. Elle dispose d'un serveur
slapd. On a l'ambition de rassembler les deux ldap des adhérent⋅es un jour mais
ça risque de pas convergé (c.f. constellation).

Redémarrage et mise à jour automatique.

### neree : galene
C'est le serveur galene du crans, l'un des deux logiciels qu'on utilise pour
faire de la visio conférence.

Redémarrage et mise à jour automatique.

### jitsi: 
C'est le serveur jitsi du crans, l'autre logiciel qu'on utilise pour faire
de la visio conférence.

Redémarrage et mise à jour automatique.

### ferle : anchor ripe
C'est la machine virtuelle qu'on met à disposition du ripe pour être des bons
élèves. On a donc pas accès à la machine.

### boeing : pont wireguard
C'est la machine qui héberge la plupart des ponts wireguard qu'on a vers
l'exterieur (sputnik, thot, ft).

Redémarrage et mise à jour automatique.

### fluxx : à bruler
Redémarrage et mise à jour automatique.

### linx : serveur d'hébergement de fichier
C'est la machine virtuelle qui héberge le logiciel éponyme.

Redémarrage et mise à jour automatique.

### cas : cas
C'est le cas. (django-cas)

Redémarrage et mise à jour automatique.

### fyre : monitoring
C'est la machine virtuelle qui monitore l'état de l'infrastructure. Il utilise
la suite de logiciels prometheus, grafana et ninjaaa(bot).

Redémarrage et mise à jour automatique.

### ecilis : dns de test
C'est une machine virtuelle qui fait partie de l'infrastructure de test et qui
héberge un dns authoritaire (knot).

Redémarrage et mise à jour automatique.

### trinity : pont matrix
C'est le pont matrix qui permet aux utilisateurices de matrix de participer aux
discutions sur irc.

Redémarrage :
  - pas de redémarrage automatique
  - le redémarrage déconnecte les utilisateurices

### irc: le serveur irc
C'est le serveur irc du crans.

Redémarrage :
  - pas de redémarrage automatique
  - le redémarrage déconnecte les utilisateurices

### kiwi: le wiki
C'est le wiki du crans qui tourne avec moinmoin2 (c'est du python2 donc il faut pas mettre à jour debian qui va drop python2).

Redémarrage et mise à jour automatique.

### redisdead : serveur mail principale
C'est le serveur mail principale du crans, c'est sur lui que les mails arrivent
et de lui que les mails partent. Ce n'est cependant pas la destination finale
des mails qui sont redirigés vers zamok. C'est un serveur postfix, mais il y a
aussi un serveur opendkim et policyd sur la machine.

Redémarrage et mise à jour automatique.

### en7 : la connexion de secours
L'ens nous a donné une ip de secours sur leur réseaux au cas où il y ait un
problème sur les routeurs et qu'on ait besoin de se connecter sur le réseaux. Il
est projetté d'y hébergé un serveur dns et un serveur mail.

Redémarrage :
  - pas de redémarrage automatique
  - redémarrage manuel possible (sauf en période de crise et faire attention si c'est votre point d'entrée adm)

### owl : serveur pop3/imap
C'est le serveur qui expose aux adhérentes leur email en imap ou en pop3.

Redémarrage et mise à jour automatique.

### re2o: la gestion des adhérent⋅es
C'est l'intranet du Crans.

Redémarrage et mise à jour automatique.

### yson-partout: le ldap des adhérent⋅es
C'est le ldap qui liste les comptes des adhérent⋅es depuis re2o.

Redémarrage et mise à jour automatique.

### helloworld: le serveur d'impression
C'est le serveur qui heberge le service web pour l'impression

Redémarrage et mise à jour automatique.

### listenup: ???
J'ai aucune idée de l'utilité de cette VM.

Redémarrage :
  - pas de redémarrage automatique

### netns:

Redémarrage et mise à jour automatique.

### proxy-pve-adh:
Comme son nom l'indique...

Redémarrage et mise à jour automatique.

### romanesco: le dns récursif
C'est le serveur DNS récursif du Crans.

Liste de logiciels installés :
  - unbound

Redémarrage et mise à jour automatique.

### silice: le dns
C'est le serveur DNS du Crans.

Liste de logiciels installés :
  - bind

Redémarrage et mise à jour automatique.

## Hodaur : le serverse proxy
C'est le reverse proxy.

Liste de logiciels installés :
 - nginx

Redémarrage et mise à jour automatique.

### … (les serveur avec "-dev" dans le nom ou un nom très proche d'un serveur de la liste sont des serveurs de test qui ont plus ou moins la même conf que le serveur copié)

## Gulp, Odlyd, Stitch : le cluster proxmox des adhérent⋅es
Les trois serveurs sont organisés en un cluster proxmox pour hébergé les
machines virtuelles des adhérent⋅es.

Liste de logiciels installés :
  - proxmox

Redémarrage :
  - pas de redémarrage automatique
  - migrer les VM avant de redémarrer

## Thot, Ft : les serveurs de backups
Ces deux serveurs ne sont pas dans la baie mais à des endroits distincts pour
éviter qu'un accident dans la salle serveur détruise toutes les données. Thot
est chez via et ft chez auro.re (une chance sur deux que je me sois trompée et
que c'est l'inverse). Ce sont des serveurs proxmox, donc peu de choses tournent
sur les machines. On décrit dans les sections qui suiventt les vms qui sont
hébergés sur ces serveurs.

Liste de logiciels installés :
  - proxmox

Redémarrage :
  - pas de redémarrage automatique
  - redémarrage manuel possible (éviter si l'autre serveur de backup à des problèmes car on a pas aacès directement aux machines en cas de problème)

## routeur-{ft,thot} : les routeurs
Ces deux machines virtuelles servent à connecter leur hyperviseur et les
machines virtuelles qu'il héberge au reste du réseau d'administration via un
tunnel wireguard dont l'autre pair est boeing.

Liste de logiciels installés :
  - wireguard

Redémarrage et mise à jour automatique.

## backup-{ft,thot} : les serveurs de backup
C'est sur ces machines virtuelles que sont effectivement faites les backups via
borgmatic.

Liste de logiciels installés :
  - borgmatic

Redémarrage et mise à jour automatique.

## Zbee : un serveur physique
Un serveur physique qui sert pas.

Redémarrage :
  - pas de redémarrage automatique